#!/usr/bin/env python

import random, re, time
import unittest

from binascii import a2b_hex, b2a_hex
from pycryptopp.hash import hmac, sha256

def randstr(n):
    return ''.join(map(chr, map(random.randrange, [0]*n, [256]*n)))

#multiple times hmac using different key and different messages
def HMAC_Bench1():
    print "HMAC_Bench1 starting\n"
    start_time = time.clock()
#    i=1
    for keylen in xrange(100):
	for msglen in xrange(100):
#	    for times in xrange(10):
#		print i, '\n'
#		i+=1
		key = randstr(keylen)
		msg = randstr(msglen)
		h = hmac.new(key, msg, sha256.SHA256)
		h.digest()

    stop_time = time.clock()
    print "multiple times hmac using different random key and different random messages, 100 random keys * 100 messages with lenth from 0 to 99, Bench1: ", stop_time-start_time,'sec \nHMAC_Bench1 ending\n'

#using a key hmac a short message
def HMAC_Bench2():
    print "HMAC_Bench2 starting\n"
    start_time = time.clock()
    key = randstr(100)
    msg = randstr(10)
    h = hmac.new(key, msg, sha256.SHA256)
    h.digest()
    stop_time = time.clock()
    print "using a key hmac a short message, Bench2: ", stop_time-start_time,"sec \n"
    print "HMAC_Bench2 ending\n\n\n"

def HMAC_Bench3():
    print "hmac bench3 starting\n"
    start_time = time.clock()
    k1 = "k"*100
    m1 = "a"*10000000
    h1 = hmac.new(k1, m1, sha256.SHA256)
    h1.digest()
    stop_time = time.clock()
    print "using a fixed 100 bytes key hmac a 10^7 bytes long fixed long message:\n", stop_time-start_time, 'sec \n' 
    print "another one using a random string"
    start_time = time.clock()
    k2=randstr(100)
    m2=randstr(10000000)
    h2 = hmac.new(k2, m2, sha256.SHA256)
    h2.digest()
    stop_time = time.clock()
    print "using a random 100 bytes key hmac a 10^7 bytes long random message, Bench3: ", stop_time-start_time,"sec \n"
    print "As we can see, most of time is spent on random string generation \nhmac bench3 ending\n\n\n"

def HMAC_Bench4():
    print "hmac bench4 starting\n"
    k = "k"*100
    m = "b"*10000000
    start_time = time.clock()
    for times in xrange(1000):
        h = hmac.new(k, m , sha256.SHA256)
	h.digest()
    stop_time = time.clock()
    print "hmac a 10^7 bytes long message 1000 times, Bench4: ", stop_time-start_time, "sec \n"
    print "hmac bench4 ending\n\n\n"

    
def main():
    HMAC_Bench4()
    HMAC_Bench3()
    HMAC_Bench2()
    HMAC_Bench1()

if __name__=="__main__":
    main()
	
