#!/usr/bin/env python

import random, re
import unittest

from binascii import a2b_hex, b2a_hex
from pkg_resources import resource_string

from pycryptopp.hash import hmac, sha256
TEST_HMAC_RE=re.compile("\nCOUNT=([0-9]+)\nKEY=([0-9a-f]+)\nDATA=([0-9a-f]+)\nHMAC-SHA256=([0-9a-f]+)")

class HMACTest(unittest.TestCase):
    def test_HMAC(self):
        curfile = open('../testvectors/HMACMsg.txt', 'r')
	s = curfile.read()
	print s,"\n"
	return self._test_HMAC(s)

    def _test_HMAC(self, vects_str):
        for mo in TEST_HMAC_RE.finditer(vects_str):
	    count = int(mo.group(1))
#	    print "hello", count, "\n"
	    key = a2b_hex(mo.group(2))
	    data = a2b_hex(mo.group(3))
	    hmacvalue = mo.group(4)

	    length = len(hmacvalue)
	    h = hmac.new(key,data,sha256.SHA256)
	    computedhmacvalue = b2a_hex(h.digest())
	    self.failUnlessEqual(computedhmacvalue[:length],hmacvalue,"computedhmac: %s, hmac: %s" % (computedhmacvalue, hmacvalue))

if __name__ == "__main__":
    unittest.main()
